import { DVCFeatureSet, DVCVariableSet } from './types';
import { DVCVariable } from './Variable';
declare type eventHandler = (...args: any[]) => void;
export declare class EventEmitter extends EventTarget {
    events: Record<string, {
        handler: eventHandler;
        handlerWrapper: eventHandler;
    }[]>;
    constructor();
    subscribe(key: string, handler: eventHandler): void;
    unsubscribe(key: string, handler?: eventHandler): void;
    emit(key: string, ...args: any[]): void;
    emitInitialized(success: boolean): void;
    emitError(error: unknown): void;
    emitConfigUpdate(newVariableSet: DVCVariableSet): void;
    emitVariableUpdates(oldVariableSet: DVCVariableSet, newVariableSet: DVCVariableSet, variableDefaultMap: {
        [key: string]: {
            [defaultValue: string]: DVCVariable<any>;
        };
    }): void;
    emitFeatureUpdates(oldFeatureSet: DVCFeatureSet, newFeatureSet: DVCFeatureSet): void;
}
export {};
